import { IBootstrapBuilder } from './IBootstrapBuilder';
import { IocModule } from './ModuleType';
import { Token, IContainer } from '@ts-ioc/core';
/**
 * bootstrap base builder.
 *
 * @export
 * @class BootstrapBuilder
 * @implements {IBootstrapBuilder}
 * @template T
 */
export declare class BootstrapBuilder implements IBootstrapBuilder {
    constructor();
    build<T>(iocModule: IocModule<T>, data?: any): Promise<T>;
    getBootstrapToken(iocModule: IocModule<any>): Token<any>;
    /**
     * bundle instance via config.
     *
     * @param {T} instance
     * @param {IocModule<any>} config
     * @returns {Promise<any>}
     * @memberof IModuleBuilder
     */
    buildStrategy(instance: any, iocModule: IocModule<any>): Promise<any>;
    getBuilder(iocModule: IocModule<any>): IBootstrapBuilder;
    protected getBuilderViaConfig(builder: Token<IBootstrapBuilder> | IBootstrapBuilder, container: IContainer): IBootstrapBuilder;
    static classAnnations: any;
}
